make_sprite_from_tile_ab: #a = tile x, b = tile y
	push x1
	push x2
	#First get the tile
	push hl
	push ba
	mov h,0
	mov l,[mapw]
	mov a,b
	mul l,a #Contains y offset..
	pop ba
	mov b,0
	add hl,ba #Contains linear tile location
	mov a,[hl] #Contains tile
	pop hl
	#h contains 0 or 1, 0 being the left eight pixels, 1 being the right
	#l contains 0 or 1, 0 being the top eight pixels, 1 being the lower
	mov x1,tiles
	add x1,ba #tile in memory
	mov x2,tl_masks
	add x2,ba #mask in memory
	#Set image data from x1 to sprite
	#Inverse (not) mask data and set to sprite
	#Sprite format:
	#Bytes 0-7: Upper left mask
	#Bytes 8-15: Lower left mask
	#Bytes 16-23: Upper left colours
	#Bytes 24-31: Lower left colours
	#Bytes 32-39: Upper right mask
	#Bytes 40-47: Lower right mask
	#Bytes 48-55: Upper right colours
	#Bytes 56-63: Lower right colours
	mov a,h
	test a,0
	jnz _is_left
	mov a,l
	test a,0
	jnz _is_upper_right
	jmp _is_lower_right
_is_left:
	mov a,l
	test a,0
	jnz _is_upper_left
	#_is_lower_left
	mov h,8
	mov l,24
	jmp _draw
_is_upper_left:
	mov h,0
	mov l,16
	jmp _draw
_is_upper_right:
	mov h,32
	mov l,48
	jmp _draw
_is_lower_right:
	mov h,40
	mov l,56
_draw:
	#h = mask location, l = colour location
	push x1
	mov a,h
	mov b,0
	add ba,invispr1
	mov x1,ba #mask location in sprite
	mov b,8
_mask_loop:
	mov [x1],[x2]
	inc x1
	inc x2
	jdbnz _mask_loop
	pop x1
	mov a,l
	mov b,0
	mov x2,ba #colour location in sprite
	mov b,8
_colr_loop:
	mov [x2],[x1]
	inc x2
	inc x1
	jdbnz _colr_loop
#Completely drawn?
	mov x1,mainchar1
	mov b,16
_fill:
	mov [x1],0
	inc x1
	jdbnz _fill
	mov b,16
_fill2:
	mov [x1],1
	inc x1
	jdbnz _fill2
_iloop:
	jmp _iloop
	pop x2
	pop x1
	ret